# read_write_lock Class Reference

`#include <_rwlock.h>`

Inheritance diagram for read_write_lock:

List of all members.

## Public Member Functions

| read_write_lock ()
| ~read_write_lock ()
void | lock_read (void)
void | lock_write (void)
bool | try_lock_read (void)
bool | try_lock_write (void)
void | unlock_write (void)
void | unlock_read (void)

## Classes

class | read_lock
| Exception-safe read-lock class. More...
class | write_lock
| Exception-safe write-lock class. More...

## Detailed Description

======================================================================== Extended Template and Library Mutex Abstraction Class Implementation $Id$

Copyright (c) 2002 Robert B. Quattlebaum Jr.

This package is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

=== N O T E S ===========================================================

This is an internal header file, included by other ETL headers. You should not attempt to use it directly.

=========================================================================

Definition at line 38 of file _rwlock.h.

## Constructor & Destructor Documentation

read_write_lock::read_write_lock | ( |  | ) | `[inline]`

Definition at line 42 of file _rwlock.h.

read_write_lock::~read_write_lock | ( |  | ) | `[inline]`

Definition at line 45 of file _rwlock.h.

## Member Function Documentation

void read_write_lock::lock_read | ( | void |  | ) | `[inline]`

Definition at line 68 of file _rwlock.h.

Referenced by read_write_lock::read_lock::read_lock().

void read_write_lock::lock_write | ( | void |  | ) | `[inline]`

Definition at line 71 of file _rwlock.h.

Referenced by read_write_lock::write_lock::write_lock().

bool read_write_lock::try_lock_read | ( | void |  | ) | `[inline]`

Definition at line 74 of file _rwlock.h.

bool read_write_lock::try_lock_write | ( | void |  | ) | `[inline]`

Definition at line 77 of file _rwlock.h.

void read_write_lock::unlock_write | ( | void |  | ) | `[inline]`

Definition at line 80 of file _rwlock.h.

Referenced by read_write_lock::write_lock::~read_lock().

void read_write_lock::unlock_read | ( | void |  | ) | `[inline]`

Definition at line 83 of file _rwlock.h.

Referenced by read_write_lock::read_lock::~read_lock().

The documentation for this class was generated from the following file:

- _rwlock.h